// abbage.cpp: implementation of the Cabbage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sprite.h"
#include "Texture.h"
#include "Cabbage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Cabbage::Cabbage()
{

}

Cabbage::~Cabbage()
{

}

void Cabbage::Render()
{
	sprite.Render();
}

int Cabbage::Move(float xPos, float yPos)
{
	timer += m;
	attackTimer -= m;
	float s = sin(timer) * 50;
	if(s > 0)
	{
		sprite.visible = true;
		int frame = int(s * 0.1f);
		if(frame < 0)
			frame = 0;
		if(frame > 2)
			frame = 2;
		sprite.texture = tex[frame];
		float xDist = xPos - sprite.xPos;
		float yDist = yPos - sprite.yPos;
		float dist = sqrt(xDist*xDist + yDist*yDist);
		if(dist < 10 && attackTimer < 0)
		{
			attackTimer = 0.5f;
			return 10;
		}
	}else{
		sprite.visible = false;
		sprite.xPos = (rand() % 180) - 90;
		sprite.yPos = (rand() % 180) - 90;
	}
	return 0;
}

void Cabbage::Setup()
{
	sprite.width = 12;
	sprite.height = 12;
	sprite.xPos = (rand() % 180) - 90;
	sprite.yPos = (rand() % 180) - 90;
	sprite.texture = tex[0];
	sprite.zDepth = 2;
	timer = float(rand() % 1000) / 500.0f;
	attackTimer = 3;
	timer = 0;
}

int Cabbage::GetType()
{
	return 5;
}
