// StoryHandler.cpp: implementation of the StoryHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sprite.h"
#include "Camera.h"
#include "TransitionHandler.h"
#include "TextRenderer.h"
#include "MenuHandler.h"
#include "StoryHandler.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

StoryHandler::StoryHandler()
{

}

StoryHandler::~StoryHandler()
{
	background.texture.Unload();
}

void StoryHandler::Initialize()
{
	background.texture.Load("Textures/story.gif", Colour(0,0,0,0));
	background.width = 100;
	background.height = 100;
	cam.viewHeight = 100;
	cam.viewWidth = 100;
}

void StoryHandler::OnMouse(float x, float y)
{
	mouseX = (x * 100.0f) - 50.0f;
	mouseY = (y * 100.0f) - 50.0f;
}

void StoryHandler::OnMouseUp(bool lmb, bool rmb)
{
	if(mouseY < -35.0f && mouseX < -32.0f)
	{
		//Transition to the menu dialog when the Page Curl is clicked
		TransitionHandler* t = new TransitionHandler;
		MenuHandler* menu = new MenuHandler;
		menu->retLevel = lvl;
		menu->Initialize();
		if(bInGame)
			menu->LoadLevel(2);
		else
			menu->LoadLevel(1);
		t->Initialize();
		t->BeginTransition(this, menu, 15);
		state = t;
	}
}

void StoryHandler::Render()
{
	glEnable(GL_LIGHTING);
	float light[] = {1.0f, 1.0f, 1.0f, 1.0f};
	glMaterialfv(GL_FRONT, GL_AMBIENT, light);

	cam.Render();
	background.Render();
}

void StoryHandler::OnKeys(bool keys[])
{
	if(keys[VK_BACK])
	{
		//Transition to the menu dialog when Backspace is pressed
		TransitionHandler* t = new TransitionHandler;
		MenuHandler* menu = new MenuHandler;
		menu->Initialize();
		menu->LoadLevel(1);
		t->Initialize();
		t->BeginTransition(this, menu, 15);
		state = t;
	}
}
