// TextRenderer.cpp: implementation of the TextRenderer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TextRenderer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HDC TextRenderer::dc;

TextRenderer::TextRenderer()
{
	zDepth = 1;
	//Generate the display lists that contain the bitmap for each character
	base = glGenLists(128);
	
	//Create a descriptor of the font
	lf.lfHeight = -14;
	lf.lfWidth = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	lf.lfWeight = FW_BOLD;
	lf.lfItalic = FALSE;
	lf.lfUnderline = FALSE;
	lf.lfStrikeOut = FALSE;
	lf.lfCharSet = ANSI_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(lf.lfFaceName, "Comic Sans MS");

	//Get a font handle
	hFont = CreateFontIndirect(&lf);
	
	//Select the font and fill the display lists
	HFONT oldFont = (HFONT)SelectObject(dc, hFont);
	wglUseFontBitmaps(dc, 0, 128, base);
	SelectObject(dc, oldFont);

	//Free the font handle
	DeleteObject(hFont);
}

TextRenderer::~TextRenderer()
{
	glDeleteLists(base, 128);
}

void TextRenderer::LoadFromFile(char *sFile)
{
	ifstream file;
	file.open(sFile);
	if(file.fail())
		return;
	char buf[1256];
	while(!file.eof())
	{
		file.getline(buf, 1256);
		text += buf;
		text += '\n';
	}
	file.close();
}

void TextRenderer::Render(float x, float y)
{
	glPushMatrix();
		glTranslatef(0,0, -zDepth);
		glDisable(GL_TEXTURE_2D);
		glColor4ub(colour.r, colour.g, colour.b, colour.a);
		glListBase(base);
		float yPos = y;
		string s;
		s.reserve(text.size());
		for(int i = 0; i < text.size(); i++)
		{
			if(text[i] == '\n')
			{
				glRasterPos2f(x, yPos);
				glCallLists(s.size(), GL_UNSIGNED_BYTE, s.c_str());
				yPos -= (float)11;
				s.erase();
			}else{
				s += text[i];
			}
		}
		if(!s.empty())
		{
			glRasterPos2f(x, yPos);
			glCallLists(s.size(), GL_UNSIGNED_BYTE, s.c_str());
		}
	glPopMatrix();
}

void TextRenderer::Clear()
{
	text.erase();
}

void TextRenderer::CreateFont()
{
	//Free the display lists
	glDeleteLists(base, 128);

	//Generate the display lists that contain the bitmap for each character
	base = glGenLists(128);

	//Get a font handle
	hFont = CreateFontIndirect(&lf);
	
	//Select the font and fill the display lists
	HFONT oldFont = (HFONT)SelectObject(dc, hFont);
	wglUseFontBitmaps(dc, 0, 128, base);
	SelectObject(dc, oldFont);

	//Free the font handle
	DeleteObject(hFont);
}
