// Texture.h: interface for the Texture class.
//
//////////////////////////////////////////////////////////////////////

#ifndef TEXTURE_H_INCLUDED
#define TEXTURE_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif

struct Colour
{
	unsigned char r,g,b,a;
	Colour()
	{
		r=g=b=0;
		a=255;
	}
	Colour(char R, char G, char B, char A) : r(R), g(G), b(B), a(A)
	{
	}
	void Set(char R, char G, char B, char A)
	{
		r=R;
		g=G;
		b=B;
		a=A;
	}
	bool operator == (Colour other)
	{
		return	r == other.r &&
				g == other.g && 
				b == other.b &&
				a == other.a;
	}
};

class Texture  
{
public:
	void Unload();
	bool Load(const char* file);
	virtual bool Load(const char* file, Colour key);
	virtual void Render();
	float uMin, vMin;
	float uMax, vMax;
	unsigned int textureID;
	Texture();
	virtual ~Texture();
	operator = (Texture& other)
	{
		textureID = other.textureID;
	}
	bool operator == (Texture& other)
	{
		if(textureID != other.textureID)
			return false;
		if(uMin != other.uMin)
			return false;
		if(uMax != other.uMax)
			return false;
		if(vMin != other.vMin)
			return false;
		if(vMax != other.vMax)
			return false;

		return true;
	}
	bool operator > (Texture& other)
	{
		return textureID > other.textureID;
	}
	bool operator < (Texture& other)
	{
		return textureID < other.textureID;
	}
};

#endif