// TransitionHandler.cpp: implementation of the TransitionHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TransitionHandler.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TransitionHandler::TransitionHandler()
{

}

TransitionHandler::~TransitionHandler()
{

}

void TransitionHandler::Update()
{
	value += 16.0f * m;
	if(value >= startValue)
	{
		delete start;
		state = end;
		delete this;
	}
}

void TransitionHandler::BeginTransition(EventHandler *e1, EventHandler *e2, float time)
{
	start = e1;
	end = e2;
	value = time * -0.5f;
	startValue = time * 0.5f;
}

void TransitionHandler::Render()
{
	//Change the ambient light
	float ambient = fabs(value) / startValue;
	float light[] = {ambient, ambient, ambient, 1.0f};
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light);

	//Render the scene
	if(value < 0)
	{
		start->Render();
	}else{
		end->Render();
	}
}
